/* libxml-Error.c generated by valac 0.28.0, the Vala compiler
 * generated from libxml-Error.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <libxml/xmlerror.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	GXML_ERROR_NOT_SUPPORTED,
	GXML_ERROR_PARSER,
	GXML_ERROR_WRITER
} GXmlError;
#define GXML_ERROR gxml_error_quark ()


GQuark gxml_error_quark (void);
gchar* gxml_libxml2_error_to_string (xmlError* e);
const gchar* xml_error_level_to_string (xmlErrorLevel self);
static const char* _xml_error_level_to_string (xmlErrorLevel value);


GQuark gxml_error_quark (void) {
	return g_quark_from_static_string ("gxml_error-quark");
}


static const char* _xml_error_level_to_string (xmlErrorLevel value) {
	switch (value) {
		case XML_ERR_NONE:
		return "XML_ERR_NONE";
		case XML_ERR_WARNING:
		return "XML_ERR_WARNING";
		case XML_ERR_ERROR:
		return "XML_ERR_ERROR";
		case XML_ERR_FATAL:
		return "XML_ERR_FATAL";
	}
	return NULL;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* gxml_libxml2_error_to_string (xmlError* e) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	xmlError* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	xmlError* _tmp5_ = NULL;
	xmlErrorLevel _tmp6_ = 0;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	xmlError* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	xmlError* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	xmlError* _tmp18_ = NULL;
	gint _tmp19_ = 0;
	xmlError* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	_tmp1_ = e;
	_tmp2_ = (*_tmp1_).file;
	if (_tmp2_ == NULL) {
		_tmp0_ = "<io>";
	} else {
		xmlError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		_tmp3_ = e;
		_tmp4_ = (*_tmp3_).file;
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = e;
	_tmp6_ = (*_tmp5_).level;
	_tmp7_ = _xml_error_level_to_string (_tmp6_);
	_tmp8_ = string_replace (_tmp7_, "XML_ERR_", "");
	_tmp9_ = _tmp8_;
	_tmp10_ = e;
	_tmp11_ = (*_tmp10_).domain;
	_tmp12_ = g_strdup_printf ("%i", _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = string_replace (_tmp13_, "XML_FROM_", "");
	_tmp15_ = _tmp14_;
	_tmp16_ = e;
	_tmp17_ = (*_tmp16_).code;
	_tmp18_ = e;
	_tmp19_ = (*_tmp18_).line;
	_tmp20_ = e;
	_tmp21_ = (*_tmp20_).message;
	_tmp22_ = g_strdup_printf ("%s:%s:%d: %s:%d: %s", _tmp9_, _tmp15_, _tmp17_, _tmp0_, _tmp19_, _tmp21_);
	_tmp23_ = _tmp22_;
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp9_);
	result = _tmp23_;
	return result;
}



